function SongTitanic()
% Student homework

fs = 44100;

zero = rest(4,fs);     % 1.0 sec
zeroh = rest(8,fs);    % 0.5 sec
zerohh = rest(16,fs);  % 0.25 sec

do = key(52,8,fs);     % c-do 1 from wikipedia eighth note as 0.5 sec
re = key(54,8,fs);     % d-re 2
mi = key(56,8,fs);     % e-mi 3
fa = key(57,8,fs);     % f-fa 4
so = key(59,8,fs);     % g-so 5
la = key(61,8,fs);     % a-la 6
si = key(63,8,fs);     % h-si 7

do_4 = key(52,4,fs);   % do 1 from wikipedia quarter note as 1 sec
re_4 = key(54,4,fs);   % re 2
mi_4 = key(56,4,fs);   % mi 3
fa_4 = key(57,4,fs);   % fa 4
so_4 = key(59,4,fs);   % so 5
la_4 = key(61,4,fs);   % la 6
si_4 = key(63,4,fs);   % si 7


%song
line1 = [ fa fa fa fa mi fa fa_4 mi fa so la_4 so fa fa fa fa mi fa_4 fa do do_4];
line2 = [fa fa fa fa mi fa fa_4 mi fa so la_4 so fa fa fa fa mi fa_4 fa do do_4 ];
line3 = [fa so do do si la so la si la so fa mi fa mi re do ];
line4 = [ fa so do do si la so la si la so fa mi fa fa mi fa so la so fa_4 fa_4];

song = [line1 line2 line3 line4]; 

% plotting(song)
sound(song,fs,24);

% ###############################################################

function wave = key(p, n, fs)
    t = 0:1/fs:4/n;
    idx = 440*2^((p-49)/12);
    
%   first method - not very natural one 
%   wave = (sin(2*pi*idx*t));

%   second method (exponential decreasing)-better one but not the best
%   tt = 4/n:-1/fs:0;
%   wave = (sin(2*pi*idx*t)).*exp(tt);
%   wave = wave./max(wave);
    
%   third method (triangle decreasing)-clear tone
    mid = (t(1)+t(end))/2;
    tri = -(abs(t-mid)-mid);
    tri = tri./max(tri);
    wave = (sin(2*pi*idx*t)).*tri;
    
%   plot(wave)


function wave = rest(n,fs)
    t = 0:1/fs:4/n;
    tt = 4/n:-1/fs:0;
    wave = 0*sin(2*pi*t).*exp(tt); 
